import { PointType } from "../types";
import { BaseAction } from "../actions/BaseAction";
import { BaseEntity } from "../BaseEntity";
import { DiagramEngine } from "../DiagramEngine";
import { DiagramModel } from "../models/DiagramModel";
import { ZoomSettings } from "../gears/SettingsGear";
export default abstract class AbstractBoard extends BaseEntity {
    protected canvas: Element;
    protected engine: DiagramEngine;
    constructor(engine: DiagramEngine);
    setCanvas(canvas: Element): void;
    getCanvas(): Element;
    abstract getRelativePoint(x: any, y: any): PointType;
    abstract navigate(action: BaseAction, event: MouseEvent): any;
    abstract navigateTo(coordinates: PointType): any;
    canPlaceNode(coords: PointType): boolean;
    zoom(level: number, settings?: ZoomSettings): void;
    protected getModels(): DiagramModel;
}
